
(*s On dfinit un type de liste de couples d'entiers, pour conomiser
de l'espace par rapport aux listes prdfinies. *)

type bucketlist =
    Empty
  | Cons of int * int * bucketlist

let size = 1466333

let table = Array.create size Empty

(*s On hache de manire efficace avec la somme des deux entiers, en tenant
compte du fait que les deux bits de poids faible du premier valent
0. *)

let hash (a1,a2) = (a1 lsr 2) + a2

(*s Le reste est classique... *)

let add ((a,b) as key) =
  let i = (hash key) mod size in
  table.(i) <- Cons(a, b, table.(i))

let mem ((a,b) as key) =
  let rec mem_in_bucket = function
  | Empty ->
      false
  | Cons(c, d, rest) ->
      (a == c && b == d) || mem_in_bucket rest 
  in
  mem_in_bucket table.((hash key) mod size)
