
(*i*)
open Coups
(*i*)

(*s L'algorithme suivant est un backtracking classique, o l'on teste
si une position a dj t rencontre. *)

exception Echec

let rec backtrack sol p =
  if p = arrivee then
    sol
  else begin
    HashPos.add p;
    let rec essaye = function
      | [] -> raise Echec
      | c::r -> 
	  if est_possible p c then
	    let p' = joue p c in
	    if not (HashPos.mem p') then
	      try backtrack (c::sol) p' with Echec -> essaye r
	    else
	      essaye r
	  else
	    essaye r
    in
    essaye tous_les_coups
  end
    
(*s Le programme principal appelle [backtrack] sur la position de
dpart, et affiche la solution. *)

let _ = 
  let s = backtrack [] depart in
  affiche_solution s

